diff --git a/gcc/testsuite/gcc.dg/vect/fast-math-bb-slp-call-3.c b/gcc/testsuite/gcc.dg/vect/fast-math-bb-slp-call-3.c
index 51443da..2471bc8 100644
--- a/gcc/testsuite/gcc.dg/vect/fast-math-bb-slp-call-3.c
+++ b/gcc/testsuite/gcc.dg/vect/fast-math-bb-slp-call-3.c
@@ -1,5 +1,9 @@
-#include <stdlib.h>
-#include <math.h>
+extern double sqrt (double);
+extern double fabs (double);
+extern double ceil (double);
+extern double floor (double);
+
+extern void abort (void);
 
 #define MIN(a, b) (((a) < (b)) ? (a) : (b))
 #define MAX(a, b) (((a) > (b)) ? (a) : (b))
diff --git a/gcc/testsuite/gcc.dg/vect/no-trapping-math-vect-ifcvt-11.c b/gcc/testsuite/gcc.dg/vect/no-trapping-math-vect-ifcvt-11.c
index b2a4230..7316985 100644
--- a/gcc/testsuite/gcc.dg/vect/no-trapping-math-vect-ifcvt-11.c
+++ b/gcc/testsuite/gcc.dg/vect/no-trapping-math-vect-ifcvt-11.c
@@ -2,7 +2,6 @@
 /* { dg-require-effective-target vect_float } */
 
 #include <stdarg.h>
-#include <signal.h>
 #include "tree-vect.h"
 
 #define N 16
diff --git a/gcc/testsuite/gcc.dg/vect/no-trapping-math-vect-ifcvt-12.c b/gcc/testsuite/gcc.dg/vect/no-trapping-math-vect-ifcvt-12.c
index ee5ec03..e87bcb8 100644
--- a/gcc/testsuite/gcc.dg/vect/no-trapping-math-vect-ifcvt-12.c
+++ b/gcc/testsuite/gcc.dg/vect/no-trapping-math-vect-ifcvt-12.c
@@ -2,7 +2,6 @@
 /* { dg-require-effective-target vect_float } */
 
 #include <stdarg.h>
-#include <signal.h>
 #include "tree-vect.h"
 
 #define N 16
diff --git a/gcc/testsuite/gcc.dg/vect/no-trapping-math-vect-ifcvt-13.c b/gcc/testsuite/gcc.dg/vect/no-trapping-math-vect-ifcvt-13.c
index dc71070..9bd583f 100644
--- a/gcc/testsuite/gcc.dg/vect/no-trapping-math-vect-ifcvt-13.c
+++ b/gcc/testsuite/gcc.dg/vect/no-trapping-math-vect-ifcvt-13.c
@@ -2,7 +2,6 @@
 /* { dg-require-effective-target vect_float } */
 
 #include <stdarg.h>
-#include <signal.h>
 #include "tree-vect.h"
 
 #define N 16
diff --git a/gcc/testsuite/gcc.dg/vect/no-trapping-math-vect-ifcvt-14.c b/gcc/testsuite/gcc.dg/vect/no-trapping-math-vect-ifcvt-14.c
index dc71070..9bd583f 100644
--- a/gcc/testsuite/gcc.dg/vect/no-trapping-math-vect-ifcvt-14.c
+++ b/gcc/testsuite/gcc.dg/vect/no-trapping-math-vect-ifcvt-14.c
@@ -2,7 +2,6 @@
 /* { dg-require-effective-target vect_float } */
 
 #include <stdarg.h>
-#include <signal.h>
 #include "tree-vect.h"
 
 #define N 16
diff --git a/gcc/testsuite/gcc.dg/vect/no-trapping-math-vect-ifcvt-15.c b/gcc/testsuite/gcc.dg/vect/no-trapping-math-vect-ifcvt-15.c
index afb9319..dcb09b7 100644
--- a/gcc/testsuite/gcc.dg/vect/no-trapping-math-vect-ifcvt-15.c
+++ b/gcc/testsuite/gcc.dg/vect/no-trapping-math-vect-ifcvt-15.c
@@ -2,7 +2,6 @@
 /* { dg-require-effective-target vect_float } */
 
 #include <stdarg.h>
-#include <signal.h>
 #include "tree-vect.h"
 
 #define N 16
diff --git a/gcc/testsuite/gcc.dg/vect/no-vfa-vect-dv-2.c b/gcc/testsuite/gcc.dg/vect/no-vfa-vect-dv-2.c
index 55a6947..4513c40 100644
--- a/gcc/testsuite/gcc.dg/vect/no-vfa-vect-dv-2.c
+++ b/gcc/testsuite/gcc.dg/vect/no-vfa-vect-dv-2.c
@@ -1,7 +1,6 @@
 /* { dg-require-effective-target vect_int } */
 
 #include <stdarg.h>
-#include <signal.h>
 #include "tree-vect.h"
 
 #define N 64
diff --git a/gcc/testsuite/gcc.dg/vect/pr40254.c b/gcc/testsuite/gcc.dg/vect/pr40254.c
index 9c8d1ec..04fc3eb 100644
--- a/gcc/testsuite/gcc.dg/vect/pr40254.c
+++ b/gcc/testsuite/gcc.dg/vect/pr40254.c
@@ -1,4 +1,3 @@
-#include <stdlib.h>
 #include <stdarg.h>
 #include "tree-vect.h"
 
diff --git a/gcc/testsuite/gcc.dg/vect/pr44507.c b/gcc/testsuite/gcc.dg/vect/pr44507.c
index d95e7c9..aeac8cd 100644
--- a/gcc/testsuite/gcc.dg/vect/pr44507.c
+++ b/gcc/testsuite/gcc.dg/vect/pr44507.c
@@ -1,6 +1,5 @@
 /* { dg-require-effective-target vect_int } */
 
-#include <stdlib.h>
 #include "tree-vect.h"
 
 int seeIf256ByteArrayIsConstant(
diff --git a/gcc/testsuite/gcc.dg/vect/pr45902.c b/gcc/testsuite/gcc.dg/vect/pr45902.c
index 00ec920..20c4351 100644
--- a/gcc/testsuite/gcc.dg/vect/pr45902.c
+++ b/gcc/testsuite/gcc.dg/vect/pr45902.c
@@ -1,7 +1,6 @@
 /* { dg-require-effective-target vect_int } */
 
 #include <stdarg.h>
-#include <stdlib.h>
 #include "tree-vect.h"
 
 #define N 128
diff --git a/gcc/testsuite/gcc.dg/vect/pr47001.c b/gcc/testsuite/gcc.dg/vect/pr47001.c
index 9f36845..53e0a4f 100644
--- a/gcc/testsuite/gcc.dg/vect/pr47001.c
+++ b/gcc/testsuite/gcc.dg/vect/pr47001.c
@@ -1,6 +1,6 @@
 /* { dg-do compile } */
 
-#include <stdlib.h>
+extern void abort (void);
 
 #define N 128
 
diff --git a/gcc/testsuite/gcc.dg/vect/pr49771.c b/gcc/testsuite/gcc.dg/vect/pr49771.c
index 95b1ed7..2dfe2ff 100644
--- a/gcc/testsuite/gcc.dg/vect/pr49771.c
+++ b/gcc/testsuite/gcc.dg/vect/pr49771.c
@@ -1,4 +1,5 @@
-#include <stdlib.h>
+extern void abort (void);
+
 #include <stdarg.h>
 
 static int a[1000];
diff --git a/gcc/testsuite/gcc.dg/vect/slp-37.c b/gcc/testsuite/gcc.dg/vect/slp-37.c
index 17e9c4f..9b1d275 100644
--- a/gcc/testsuite/gcc.dg/vect/slp-37.c
+++ b/gcc/testsuite/gcc.dg/vect/slp-37.c
@@ -1,7 +1,6 @@
 /* { dg-require-effective-target vect_int } */
 
 #include <stdarg.h>
-#include <stdlib.h>
 #include "tree-vect.h"
 
 #define N 128 
@@ -24,7 +23,7 @@ foo1 (s1 *arr)
     {
       ptr->a = 6;
       ptr->b = 7;
-      ptr->c = NULL;
+      ptr->c = 0;
       ptr++; 
     } 
    
@@ -33,7 +32,7 @@ foo1 (s1 *arr)
     { 
        if (arr[i].a != 6 
            || arr[i].b != 7
-           || arr[i].c != NULL)
+           || arr[i].c != 0)
          abort();
     }
 }
diff --git a/gcc/testsuite/gcc.dg/vect/slp-widen-mult-half.c b/gcc/testsuite/gcc.dg/vect/slp-widen-mult-half.c
index 6c26d4b..6e0ed0f 100644
--- a/gcc/testsuite/gcc.dg/vect/slp-widen-mult-half.c
+++ b/gcc/testsuite/gcc.dg/vect/slp-widen-mult-half.c
@@ -1,7 +1,6 @@
 /* { dg-require-effective-target vect_int } */
 
 #include "tree-vect.h"
-#include <stdlib.h>
 
 #define N 32
 #define COEF 32470
diff --git a/gcc/testsuite/gcc.dg/vect/vect-10-big-array.c b/gcc/testsuite/gcc.dg/vect/vect-10-big-array.c
index 67587ed..71ec0b8 100644
--- a/gcc/testsuite/gcc.dg/vect/vect-10-big-array.c
+++ b/gcc/testsuite/gcc.dg/vect/vect-10-big-array.c
@@ -1,6 +1,7 @@
 /* { dg-do compile } */
 /* { dg-require-effective-target vect_int } */
-#include <stdlib.h>
+
+extern void abort (void);
 
 #define N 128
 
diff --git a/gcc/testsuite/gcc.dg/vect/vect-117.c b/gcc/testsuite/gcc.dg/vect/vect-117.c
index f3d8a72..bb1aebc 100644
--- a/gcc/testsuite/gcc.dg/vect/vect-117.c
+++ b/gcc/testsuite/gcc.dg/vect/vect-117.c
@@ -1,6 +1,5 @@
 /* { dg-require-effective-target vect_int } */
 
-#include <stdlib.h>
 #include <stdarg.h>
 #include "tree-vect.h"
 
diff --git a/gcc/testsuite/gcc.dg/vect/vect-99.c b/gcc/testsuite/gcc.dg/vect/vect-99.c
index 0d13d4b..ae23b3a 100644
--- a/gcc/testsuite/gcc.dg/vect/vect-99.c
+++ b/gcc/testsuite/gcc.dg/vect/vect-99.c
@@ -1,6 +1,5 @@
 /* { dg-require-effective-target vect_int } */
 
-#include <stdlib.h>
 #include "tree-vect.h"
 
 int ca[100];
diff --git a/gcc/testsuite/gcc.dg/vect/vect-aggressive-1.c b/gcc/testsuite/gcc.dg/vect/vect-aggressive-1.c
index b913b0c..b18d2cb 100644
--- a/gcc/testsuite/gcc.dg/vect/vect-aggressive-1.c
+++ b/gcc/testsuite/gcc.dg/vect/vect-aggressive-1.c
@@ -2,7 +2,6 @@
 /* { dg-require-effective-target vect_simd_clones } */
 /* { dg-additional-options "-fopenmp-simd" } */
 
-#include <stdlib.h>
 #include "tree-vect.h"
 
 #define N 64
diff --git a/gcc/testsuite/gcc.dg/vect/vect-cond-1.c b/gcc/testsuite/gcc.dg/vect/vect-cond-1.c
index 3a50c6f..261d828 100644
--- a/gcc/testsuite/gcc.dg/vect/vect-cond-1.c
+++ b/gcc/testsuite/gcc.dg/vect/vect-cond-1.c
@@ -1,6 +1,5 @@
 /* { dg-require-effective-target vect_condition } */
 
-#include <stdlib.h> 
 #include "tree-vect.h"
 
 #define M 32
diff --git a/gcc/testsuite/gcc.dg/vect/vect-cond-2.c b/gcc/testsuite/gcc.dg/vect/vect-cond-2.c
index 51418c2..9a62856 100644
--- a/gcc/testsuite/gcc.dg/vect/vect-cond-2.c
+++ b/gcc/testsuite/gcc.dg/vect/vect-cond-2.c
@@ -1,6 +1,5 @@
 /* { dg-require-effective-target vect_condition } */
 
-#include <stdlib.h> 
 #include "tree-vect.h"
 
 #define N 16
diff --git a/gcc/testsuite/gcc.dg/vect/vect-cond-3.c b/gcc/testsuite/gcc.dg/vect/vect-cond-3.c
index 65c4079..8a66b4b 100644
--- a/gcc/testsuite/gcc.dg/vect/vect-cond-3.c
+++ b/gcc/testsuite/gcc.dg/vect/vect-cond-3.c
@@ -1,6 +1,5 @@
 /* { dg-require-effective-target vect_condition } */
 
-#include <stdlib.h> 
 #include "tree-vect.h"
 
 #define M 32
diff --git a/gcc/testsuite/gcc.dg/vect/vect-cond-4.c b/gcc/testsuite/gcc.dg/vect/vect-cond-4.c
index cb2a1be..2a6577c 100644
--- a/gcc/testsuite/gcc.dg/vect/vect-cond-4.c
+++ b/gcc/testsuite/gcc.dg/vect/vect-cond-4.c
@@ -1,6 +1,5 @@
 /* { dg-require-effective-target vect_condition } */
 
-#include <stdlib.h> 
 #include "tree-vect.h"
 
 #define M 32
diff --git a/gcc/testsuite/gcc.dg/vect/vect-ifcvt-16.c b/gcc/testsuite/gcc.dg/vect/vect-ifcvt-16.c
index 7186875..56a8e01 100644
--- a/gcc/testsuite/gcc.dg/vect/vect-ifcvt-16.c
+++ b/gcc/testsuite/gcc.dg/vect/vect-ifcvt-16.c
@@ -2,7 +2,6 @@
 /* { dg-require-effective-target vect_float } */
 
 #include <stdarg.h>
-#include <signal.h>
 #include "tree-vect.h"
 
 #define N 16
diff --git a/gcc/testsuite/gcc.dg/vect/vect-ifcvt-17.c b/gcc/testsuite/gcc.dg/vect/vect-ifcvt-17.c
index 66f15dd..962be1c 100644
--- a/gcc/testsuite/gcc.dg/vect/vect-ifcvt-17.c
+++ b/gcc/testsuite/gcc.dg/vect/vect-ifcvt-17.c
@@ -2,7 +2,6 @@
 /* { dg-require-effective-target vect_float } */
 
 #include <stdarg.h>
-#include <signal.h>
 #include "tree-vect.h"
 
 #define N 16
diff --git a/gcc/testsuite/gcc.dg/vect/vect-ifcvt-2.c b/gcc/testsuite/gcc.dg/vect/vect-ifcvt-2.c
index 3aa4948..6406875 100644
--- a/gcc/testsuite/gcc.dg/vect/vect-ifcvt-2.c
+++ b/gcc/testsuite/gcc.dg/vect/vect-ifcvt-2.c
@@ -2,7 +2,6 @@
 /* { dg-require-effective-target vect_int } */
 
 #include <stdarg.h>
-#include <signal.h>
 #include "tree-vect.h"
 
 #define N 16
diff --git a/gcc/testsuite/gcc.dg/vect/vect-ifcvt-3.c b/gcc/testsuite/gcc.dg/vect/vect-ifcvt-3.c
index 2d80603..d55440c 100644
--- a/gcc/testsuite/gcc.dg/vect/vect-ifcvt-3.c
+++ b/gcc/testsuite/gcc.dg/vect/vect-ifcvt-3.c
@@ -2,7 +2,6 @@
 /* { dg-require-effective-target vect_int } */
 
 #include <stdarg.h>
-#include <signal.h>
 #include "tree-vect.h"
 
 #define N 16
diff --git a/gcc/testsuite/gcc.dg/vect/vect-ifcvt-4.c b/gcc/testsuite/gcc.dg/vect/vect-ifcvt-4.c
index f1b56ce..5cef851 100644
--- a/gcc/testsuite/gcc.dg/vect/vect-ifcvt-4.c
+++ b/gcc/testsuite/gcc.dg/vect/vect-ifcvt-4.c
@@ -2,7 +2,6 @@
 /* { dg-require-effective-target vect_int } */
 
 #include <stdarg.h>
-#include <signal.h>
 #include "tree-vect.h"
 
 #define N 16
diff --git a/gcc/testsuite/gcc.dg/vect/vect-ifcvt-5.c b/gcc/testsuite/gcc.dg/vect/vect-ifcvt-5.c
index 05309ea..3118e2d 100644
--- a/gcc/testsuite/gcc.dg/vect/vect-ifcvt-5.c
+++ b/gcc/testsuite/gcc.dg/vect/vect-ifcvt-5.c
@@ -2,7 +2,6 @@
 /* { dg-require-effective-target vect_int } */
 
 #include <stdarg.h>
-#include <signal.h>
 #include "tree-vect.h"
 
 #define N 16
diff --git a/gcc/testsuite/gcc.dg/vect/vect-ifcvt-6.c b/gcc/testsuite/gcc.dg/vect/vect-ifcvt-6.c
index 77a749d..272fde0 100644
--- a/gcc/testsuite/gcc.dg/vect/vect-ifcvt-6.c
+++ b/gcc/testsuite/gcc.dg/vect/vect-ifcvt-6.c
@@ -2,7 +2,6 @@
 /* { dg-require-effective-target vect_int } */
 
 #include <stdarg.h>
-#include <signal.h>
 #include "tree-vect.h"
 
 #define N 16
diff --git a/gcc/testsuite/gcc.dg/vect/vect-ifcvt-7.c b/gcc/testsuite/gcc.dg/vect/vect-ifcvt-7.c
index 5ced279..c0c7a3c 100644
--- a/gcc/testsuite/gcc.dg/vect/vect-ifcvt-7.c
+++ b/gcc/testsuite/gcc.dg/vect/vect-ifcvt-7.c
@@ -2,7 +2,6 @@
 /* { dg-require-effective-target vect_int } */
 
 #include <stdarg.h>
-#include <signal.h>
 #include "tree-vect.h"
 
 #define N 16
diff --git a/gcc/testsuite/gcc.dg/vect/vect-ifcvt-9.c b/gcc/testsuite/gcc.dg/vect/vect-ifcvt-9.c
index f08b81d..e6446a7 100644
--- a/gcc/testsuite/gcc.dg/vect/vect-ifcvt-9.c
+++ b/gcc/testsuite/gcc.dg/vect/vect-ifcvt-9.c
@@ -2,7 +2,6 @@
 /* { dg-require-effective-target vect_int } */
 
 #include <stdarg.h>
-#include <signal.h>
 #include "tree-vect.h"
 
 #define N 16
diff --git a/gcc/testsuite/gcc.dg/vect/vect-mask-load-1.c b/gcc/testsuite/gcc.dg/vect/vect-mask-load-1.c
index eb12ea1..3a38b64 100644
--- a/gcc/testsuite/gcc.dg/vect/vect-mask-load-1.c
+++ b/gcc/testsuite/gcc.dg/vect/vect-mask-load-1.c
@@ -1,7 +1,6 @@
 /* { dg-additional-options "-Ofast -fno-common" } */
 /* { dg-additional-options "-Ofast -fno-common -mavx" { target avx_runtime } } */
 
-#include <stdlib.h>
 #include "tree-vect.h"
 
 __attribute__((noinline, noclone)) void
diff --git a/gcc/testsuite/gcc.dg/vect/vect-mask-loadstore-1.c b/gcc/testsuite/gcc.dg/vect/vect-mask-loadstore-1.c
index 11e9533..56b130e 100644
--- a/gcc/testsuite/gcc.dg/vect/vect-mask-loadstore-1.c
+++ b/gcc/testsuite/gcc.dg/vect/vect-mask-loadstore-1.c
@@ -1,7 +1,6 @@
 /* { dg-additional-options "-Ofast -fno-common" } */
 /* { dg-additional-options "-Ofast -fno-common -mavx" { target avx_runtime } } */
 
-#include <stdlib.h>
 #include "tree-vect.h"
 
 __attribute__((noinline, noclone)) void
diff --git a/gcc/testsuite/gcc.dg/vect/vect-neg-store-1.c b/gcc/testsuite/gcc.dg/vect/vect-neg-store-1.c
index 1efecb4..dea7283 100644
--- a/gcc/testsuite/gcc.dg/vect/vect-neg-store-1.c
+++ b/gcc/testsuite/gcc.dg/vect/vect-neg-store-1.c
@@ -1,5 +1,5 @@
 /* { dg-require-effective-target vect_int } */
-#include <stdlib.h>
+extern void abort (void);
 
 __attribute__((noinline, noclone))
 void test1(short x[128])
diff --git a/gcc/testsuite/gcc.dg/vect/vect-neg-store-2.c b/gcc/testsuite/gcc.dg/vect/vect-neg-store-2.c
index 9099eb2..3c523f0 100644
--- a/gcc/testsuite/gcc.dg/vect/vect-neg-store-2.c
+++ b/gcc/testsuite/gcc.dg/vect/vect-neg-store-2.c
@@ -1,5 +1,5 @@
 /* { dg-require-effective-target vect_int } */
-#include <stdlib.h>
+extern void abort (void);
 
 __attribute__((noinline, noclone))
 void test1(short x[128], short D)
diff --git a/gcc/testsuite/gcc.dg/vect/vect-outer-5.c b/gcc/testsuite/gcc.dg/vect/vect-outer-5.c
index d9451ab..10b558f 100644
--- a/gcc/testsuite/gcc.dg/vect/vect-outer-5.c
+++ b/gcc/testsuite/gcc.dg/vect/vect-outer-5.c
@@ -1,7 +1,6 @@
 /* { dg-require-effective-target vect_float } */
 
 #include <stdarg.h>
-#include <signal.h>
 #include "tree-vect.h"
 
 #define N 64
diff --git a/gcc/testsuite/gcc.dg/vect/vect-outer-6.c b/gcc/testsuite/gcc.dg/vect/vect-outer-6.c
index 546b583..201ca84 100644
--- a/gcc/testsuite/gcc.dg/vect/vect-outer-6.c
+++ b/gcc/testsuite/gcc.dg/vect/vect-outer-6.c
@@ -1,7 +1,6 @@
 /* { dg-require-effective-target vect_float } */
 
 #include <stdarg.h>
-#include <signal.h>
 #include "tree-vect.h"
 
 #define N 64
diff --git a/gcc/testsuite/gcc.dg/vect/vect-over-widen-1-big-array.c b/gcc/testsuite/gcc.dg/vect/vect-over-widen-1-big-array.c
index 94e4911..b701b7b 100644
--- a/gcc/testsuite/gcc.dg/vect/vect-over-widen-1-big-array.c
+++ b/gcc/testsuite/gcc.dg/vect/vect-over-widen-1-big-array.c
@@ -1,7 +1,6 @@
 /* { dg-require-effective-target vect_int } */
 /* { dg-require-effective-target vect_shift } */
 
-#include <stdlib.h>
 #include <stdarg.h>
 #include "tree-vect.h"
 
diff --git a/gcc/testsuite/gcc.dg/vect/vect-over-widen-1.c b/gcc/testsuite/gcc.dg/vect/vect-over-widen-1.c
index cfc7240..01ef4d2 100644
--- a/gcc/testsuite/gcc.dg/vect/vect-over-widen-1.c
+++ b/gcc/testsuite/gcc.dg/vect/vect-over-widen-1.c
@@ -1,7 +1,6 @@
 /* { dg-require-effective-target vect_int } */
 /* { dg-require-effective-target vect_shift } */
 
-#include <stdlib.h>
 #include <stdarg.h>
 #include "tree-vect.h"
 
diff --git a/gcc/testsuite/gcc.dg/vect/vect-over-widen-2-big-array.c b/gcc/testsuite/gcc.dg/vect/vect-over-widen-2-big-array.c
index 5be9340..651ef7c 100644
--- a/gcc/testsuite/gcc.dg/vect/vect-over-widen-2-big-array.c
+++ b/gcc/testsuite/gcc.dg/vect/vect-over-widen-2-big-array.c
@@ -1,7 +1,6 @@
 /* { dg-require-effective-target vect_int } */
 /* { dg-require-effective-target vect_shift } */
 
-#include <stdlib.h>
 #include <stdarg.h>
 #include "tree-vect.h"
 
diff --git a/gcc/testsuite/gcc.dg/vect/vect-over-widen-2.c b/gcc/testsuite/gcc.dg/vect/vect-over-widen-2.c
index b7ee047..eb9683e 100644
--- a/gcc/testsuite/gcc.dg/vect/vect-over-widen-2.c
+++ b/gcc/testsuite/gcc.dg/vect/vect-over-widen-2.c
@@ -1,7 +1,6 @@
 /* { dg-require-effective-target vect_int } */
 /* { dg-require-effective-target vect_shift } */
 
-#include <stdlib.h>
 #include <stdarg.h>
 #include "tree-vect.h"
 
diff --git a/gcc/testsuite/gcc.dg/vect/vect-over-widen-3-big-array.c b/gcc/testsuite/gcc.dg/vect/vect-over-widen-3-big-array.c
index 1ca3128..4ebe515 100644
--- a/gcc/testsuite/gcc.dg/vect/vect-over-widen-3-big-array.c
+++ b/gcc/testsuite/gcc.dg/vect/vect-over-widen-3-big-array.c
@@ -1,7 +1,6 @@
 /* { dg-require-effective-target vect_int } */
 /* { dg-require-effective-target vect_shift } */
 
-#include <stdlib.h>
 #include <stdarg.h>
 #include "tree-vect.h"
 
diff --git a/gcc/testsuite/gcc.dg/vect/vect-over-widen-3.c b/gcc/testsuite/gcc.dg/vect/vect-over-widen-3.c
index ddbf1b2..6ca6be7 100644
--- a/gcc/testsuite/gcc.dg/vect/vect-over-widen-3.c
+++ b/gcc/testsuite/gcc.dg/vect/vect-over-widen-3.c
@@ -1,7 +1,6 @@
 /* { dg-require-effective-target vect_int } */
 /* { dg-require-effective-target vect_shift } */
 
-#include <stdlib.h>
 #include <stdarg.h>
 #include "tree-vect.h"
 
diff --git a/gcc/testsuite/gcc.dg/vect/vect-over-widen-4-big-array.c b/gcc/testsuite/gcc.dg/vect/vect-over-widen-4-big-array.c
index 6e264f9..4ce532b 100644
--- a/gcc/testsuite/gcc.dg/vect/vect-over-widen-4-big-array.c
+++ b/gcc/testsuite/gcc.dg/vect/vect-over-widen-4-big-array.c
@@ -1,7 +1,6 @@
 /* { dg-require-effective-target vect_int } */
 /* { dg-require-effective-target vect_shift } */
 
-#include <stdlib.h>
 #include <stdarg.h>
 #include "tree-vect.h"
 
diff --git a/gcc/testsuite/gcc.dg/vect/vect-over-widen-4.c b/gcc/testsuite/gcc.dg/vect/vect-over-widen-4.c
index 5928c6d..cc75646 100644
--- a/gcc/testsuite/gcc.dg/vect/vect-over-widen-4.c
+++ b/gcc/testsuite/gcc.dg/vect/vect-over-widen-4.c
@@ -1,7 +1,6 @@
 /* { dg-require-effective-target vect_int } */
 /* { dg-require-effective-target vect_shift } */
 
-#include <stdlib.h>
 #include <stdarg.h>
 #include "tree-vect.h"
 
diff --git a/gcc/testsuite/gcc.dg/vect/vect-strided-u8-i8-gap4-unknown.c b/gcc/testsuite/gcc.dg/vect/vect-strided-u8-i8-gap4-unknown.c
index fde3c78..b36ab73 100644
--- a/gcc/testsuite/gcc.dg/vect/vect-strided-u8-i8-gap4-unknown.c
+++ b/gcc/testsuite/gcc.dg/vect/vect-strided-u8-i8-gap4-unknown.c
@@ -1,7 +1,6 @@
 /* { dg-require-effective-target vect_int } */
 
 #include <stdarg.h>
-#include <stdio.h>
 #include "tree-vect.h"
 
 #define N 160 
diff --git a/gcc/testsuite/gcc.dg/vect/vect-widen-mult-const-s16.c b/gcc/testsuite/gcc.dg/vect/vect-widen-mult-const-s16.c
index 377dcb0..c08bf37 100644
--- a/gcc/testsuite/gcc.dg/vect/vect-widen-mult-const-s16.c
+++ b/gcc/testsuite/gcc.dg/vect/vect-widen-mult-const-s16.c
@@ -2,7 +2,6 @@
 /* { dg-additional-options "-fno-ipa-icf" } */
 
 #include "tree-vect.h"
-#include <stdlib.h>
 
 #define N 32
 
diff --git a/gcc/testsuite/gcc.dg/vect/vect-widen-mult-const-u16.c b/gcc/testsuite/gcc.dg/vect/vect-widen-mult-const-u16.c
index 9ab677a..909e09a 100644
--- a/gcc/testsuite/gcc.dg/vect/vect-widen-mult-const-u16.c
+++ b/gcc/testsuite/gcc.dg/vect/vect-widen-mult-const-u16.c
@@ -2,7 +2,6 @@
 /* { dg-additional-options "-fno-ipa-icf" } */
 
 #include "tree-vect.h"
-#include <stdlib.h>
 
 #define N 32
 
diff --git a/gcc/testsuite/gcc.dg/vect/vect-widen-mult-half-u8.c b/gcc/testsuite/gcc.dg/vect/vect-widen-mult-half-u8.c
index 298b741..2840d968 100644
--- a/gcc/testsuite/gcc.dg/vect/vect-widen-mult-half-u8.c
+++ b/gcc/testsuite/gcc.dg/vect/vect-widen-mult-half-u8.c
@@ -2,7 +2,6 @@
 /* { dg-additional-options "-fno-ipa-icf" } */
 
 #include "tree-vect.h"
-#include <stdlib.h>
 
 #define N 32
 #define COEF 32470
diff --git a/gcc/testsuite/gcc.dg/vect/vect-widen-mult-half.c b/gcc/testsuite/gcc.dg/vect/vect-widen-mult-half.c
index 1c6e344..738925d 100644
--- a/gcc/testsuite/gcc.dg/vect/vect-widen-mult-half.c
+++ b/gcc/testsuite/gcc.dg/vect/vect-widen-mult-half.c
@@ -1,7 +1,6 @@
 /* { dg-require-effective-target vect_int } */
 
 #include "tree-vect.h"
-#include <stdlib.h>
 
 #define N 32
 #define COEF 32470